module SiteMandala

  class Configuration

    class << self

      attr_reader :token
      attr_reader :base_url

      def configure(config)
        config.stringify_keys!
        @token = config["token"]
        @base_url = config["base_url"] || "https://api.sitemandala.com"
        self
      end

      def reset!
        @token = nil
        @base_url = "https://api.sitemandala.com"
      end

      def ensure!(*params)
        params.each do |p|
          raise SiteMandala::ConfigurationError.new("'#{p}' not configured") unless instance_variable_get "@#{p}"
        end
      end

    end

    reset!

  end

end